﻿var DocumentLoaded = false;
var isNextStatusButtonEnable = false;
var isPrevStatusButtonEnable = false;

var hasError = false;
var pageCount = -1;

// performed after the page was loaded
// adds handlers to the interface elements
function Initialize() {
    $("#ssr_thumbnailButton").click(function () {
        if ($("#ssr_thumbnailsPanel").css("display") == "none") {
            ShowThumbnailPanel();
        }
        else {
            HideThumbnailPanel();
        }
    });

    $("#ssr_documentMapButton").click(function () {
        if ($("#ssr_documentMapPanel").css("display") == "none") {
            ShowDocumentMapPanel();
        }
        else {
            HideDocumentMapPanel();
        }
    });

    $("#ssr_closeThumbnailPanelButton").click(function () {
        HideThumbnailPanel();
    });

    $("#ssr_closeThumbnailPanelButton").mousedown(function () {
        $("#ssr_closeThumbnailPanelButton").addClass('ssr_closeThumbnailPanelButtonDown');
    });

    $("#ssr_closeThumbnailPanelButton").mouseup(function () {
        $("#ssr_closeThumbnailPanelButton").removeClass('ssr_closeThumbnailPanelButtonDown');
    });

    $("#ssr_closeThumbnailPanelButton").mouseout(function () {
        $("#ssr_closeThumbnailPanelButton").removeClass('ssr_closeThumbnailPanelButtonDown');
    });

    $("#ssr_closeDocumentMapPanelButton").click(function () {
        HideDocumentMapPanel();
    });

    $("#ssr_closeDocumentMapPanelButton").mousedown(function () {
        $("#ssr_closeDocumentMapPanelButton").addClass('ssr_closeDocumentMapPanelButtonDown');
    });

    $("#ssr_closeDocumentMapPanelButton").mouseup(function () {
        $("#ssr_closeDocumentMapPanelButton").removeClass('ssr_closeDocumentMapPanelButtonDown');
    });

    $("#ssr_closeDocumentMapPanelButton").mouseout(function () {
        $("#ssr_closeDocumentMapPanelButton").removeClass('ssr_closeDocumentMaplPanelButtonDown');
    });

    $(".ssr_toolButton").mousedown(function () {
        if (DocumentLoaded) {
            $(this.parentNode).removeClass("ssr_toolButtonContainerOver");
            $(this.parentNode).addClass("ssr_toolButtonContainerDown");
        }
    });

    $(".ssr_toolButton").mouseup(function () {
        if (DocumentLoaded) {
            $(this.parentNode).removeClass("ssr_toolButtonContainerDown");
            $(this.parentNode).addClass("ssr_toolButtonContainerOver");
        }
    });

    $(".ssr_toolButton").mouseout(function () {
        if (DocumentLoaded) {
            $(this.parentNode).removeClass("ssr_toolButtonContainerDown");
            $(this.parentNode).addClass("ssr_toolButtonContainerOver");
        }
    });

    $(".ssr_statusButtonBack").mousedown(function () {
        if (isPrevStatusButtonEnable) {
            $(this.parentNode).removeClass("ssr_statusButtonContainerOver");
            $(this.parentNode).addClass("ssr_statusButtonContainerDown");
        }
    });

    $(".ssr_statusButtonBack").mouseup(function () {
        if (isPrevStatusButtonEnable) {
            $(this.parentNode).removeClass("ssr_statusButtonContainerDown");
            $(this.parentNode).addClass("ssr_statusButtonContainerOver");
        }
    });

    $(".ssr_statusButtonBack").mouseout(function () {
        if (isPrevStatusButtonEnable) {
            $(this.parentNode).removeClass("ssr_statusButtonContainerDown");
            $(this.parentNode).addClass("ssr_statusButtonContainerOver");
        }
    });

    $(".ssr_statusButtonForward").mousedown(function () {
        if (isNextStatusButtonEnable) {
            $(this.parentNode).removeClass("ssr_statusButtonContainerOver");
            $(this.parentNode).addClass("ssr_statusButtonContainerDown");
        }
    });
    $(".ssr_statusButtonForward").mouseup(function () {
        if (isNextStatusButtonEnable) {
            $(this.parentNode).removeClass("ssr_statusButtonContainerDown");
            $(this.parentNode).addClass("ssr_statusButtonContainerOver");
        }
    });
    $(".ssr_statusButtonForward").mouseout(function () {
        if (isNextStatusButtonEnable) {
            $(this.parentNode).removeClass("ssr_statusButtonContainerDown");
            $(this.parentNode).addClass("ssr_statusButtonContainerOver");
        }
    });

    $("#ssr_printButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.print();
        }
    });

    $("#ssr_rtfExportButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.exportToRtf();
        }
    });

    $("#ssr_pdfExportButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.exportToPdf();
        }
    });

    $("#ssr_excelExportButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.exportToExcel();
        }
    });

    $("#ssr_htmlExportButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.exportToHtml();
        }
    });

    $("#ssr_xpsExportButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.exportToXps();
        }
    });

    $("#ssr_xlsxExportButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.exportToXlsx();
        }
    });

    $("#ssr_zoomInButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.zoomIn();
        }
    });

    $("#ssr_zoomOutButton").click(function () {
        if (DocumentLoaded) {
            reportViewer.zoomOut();
        }
    });

    $("#ssr_firstPageButton").click(function () {
        if (isPrevStatusButtonEnable) {
            reportViewer.firstPage();
            DisablePreviousFirstPage();
        }
    });

    $("#ssr_previousPageButton").click(function () {
        if (isPrevStatusButtonEnable) {
            reportViewer.prevPage();
        }
    });

    $("#ssr_lastPageButton").click(function () {
        if (isNextStatusButtonEnable) {
            reportViewer.lastPage();
            DisableNextLastPage();
        }
    });

    $("#ssr_nextPageButton").click(function () {
        if (isNextStatusButtonEnable) {
            reportViewer.nextPage();
        }
    });

    $("#ssr_currentPageNumberBox").blur(function () {
        HandelInputPageNumber(this);
    });

    $("#ssr_currentPageNumberBox").keyup(function (event) {
        if (event.keyCode == '13') {
            event.preventDefault();
            HandelInputPageNumber(this);
        }
    });

    $("#ssr_errorButton").click(function () {
        if (hasError) {
            ShowErrorDialog();
        }
    });

    DisableState();
}

 // end Initialize



// disables all visual elements
function DisableState() {
    DisableToolbarState();
    DisableNextLastPage();
    DisablePreviousFirstPage();
    DisableErrorButton();
    $("#ssr_errorMessage").empty();
}

// displays the dialog window which contains an error message
function ShowErrorDialog() {
    $("#ssr_errorDialog:ui-dialog").dialog("destroy");
    $("#ssr_errorDialog").dialog({
        "autoOpen": true,
        "height": 300,
        "modal": true,
        "width": 400,
        "minWidth": 400,
        "closeOnEscape": true,
        "buttons": {
            "Close": function () {
                $(this).dialog("close");
            }
        },
        "open": function () {
            // changes standard dialog styles
            $(this).parents(".ui-dialog:first").find(".ui-dialog-titlebar").addClass("ssr_errorDialogElementBackground");
            $(this).parents(".ui-dialog:first").find(".ui-icon").addClass("ssr_errorDialogIcon");
            $(this).parents(".ui-dialog:first").find(".ui-button").addClass("ssr_errorDialogButton ssr_errorDialogElementBackground");
            $(this).parents(".ui-dialog:first").find(".ui-button-text").addClass("ssr_errorDialogButtonText");
            $(this).parents(".ui-dialog:first").addClass("ssr_errorDialogStyle");
            $(this).parents(".ui-dialog:first").find(".ui-dialog-titlebar-close").addClass("ssr_errorDialogCloseButton");
        }

    });
}

// disables toolbar elements
function DisableToolbarState() {
    DocumentLoaded = false;

    $("#ssr_printButton").addClass("ssr_printButtonDisable");
    $("#ssr_printButton").removeClass("ssr_printButtonEnable");

    $("#ssr_rtfExportButton").addClass("ssr_rtfButtonDisable");
    $("#ssr_rtfExportButton").removeClass("ssr_rtfButtonEnable");

    $("#ssr_pdfExportButton").addClass("ssr_pdfButtonDisable");
    $("#ssr_pdfExportButton").removeClass("ssr_pdfButtonEnable");

    $("#ssr_excelExportButton").addClass("ssr_excelButtonDisable");
    $("#ssr_excelExportButton").removeClass("ssr_excelButtonEnable");

    $("#ssr_xlsxExportButton").addClass("ssr_xlsxButtonDisable");
    $("#ssr_xlsxExportButton").removeClass("ssr_xlsxButtonEnable");

    $("#ssr_htmlExportButton").addClass("ssr_htmlButtonDisable");
    $("#ssr_htmlExportButton").removeClass("ssr_htmlButtonEnable");

    $("#ssr_xpsExportButton").addClass("ssr_xpsButtonDisable");
    $("#ssr_xpsExportButton").removeClass("ssr_xpsButtonEnable");

    $("#ssr_zoomInButton").addClass("ssr_zoomInButtonDisable");
    $("#ssr_zoomInButton").removeClass("ssr_zoomInButtonEnable");

    $("#ssr_zoomOutButton").addClass("ssr_zoomOutButtonDisable");
    $("#ssr_zoomOutButton").removeClass("ssr_zoomOutButtonEnable");

    $(".ssr_toolButtonContainer").removeClass("ssr_toolButtonContainerOver");
}

// enables toolbar elements
function EnableToolbarState() {
    DocumentLoaded = true;

    $("#ssr_printButton").removeClass("ssr_printButtonDisable");
    $("#ssr_printButton").addClass("ssr_printButtonEnable");

    $("#ssr_rtfExportButton").removeClass("ssr_rtfButtonDisable");
    $("#ssr_rtfExportButton").addClass("ssr_rtfButtonEnable");

    $("#ssr_pdfExportButton").removeClass("ssr_pdfButtonDisable");
    $("#ssr_pdfExportButton").addClass("ssr_pdfButtonEnable");

    $("#ssr_excelExportButton").removeClass("ssr_excelButtonDisable");
    $("#ssr_excelExportButton").addClass("ssr_excelButtonEnable");

    $("#ssr_xlsxExportButton").removeClass("ssr_xlsxButtonDisable");
    $("#ssr_xlsxExportButton").addClass("ssr_xlsxButtonEnable");

    $("#ssr_htmlExportButton").removeClass("ssr_htmlButtonDisable");
    $("#ssr_htmlExportButton").addClass("ssr_htmlButtonEnable");

    $("#ssr_xpsExportButton").removeClass("ssr_xpsButtonDisable");
    $("#ssr_xpsExportButton").addClass("ssr_xpsButtonEnable");

    $("#ssr_zoomInButton").removeClass("ssr_zoomInButtonDisable");
    $("#ssr_zoomInButton").addClass("ssr_zoomInButtonEnable");

    $("#ssr_zoomOutButton").removeClass("ssr_zoomOutButtonDisable");
    $("#ssr_zoomOutButton").addClass("ssr_zoomOutButtonEnable");
    

    $(".ssr_toolButtonContainer").addClass("ssr_toolButtonContainerOver");
}

// enables the elements which navigate to the next and last pages
function EnableNextLastPage() {
    isNextStatusButtonEnable = true;

    $("#ssr_nextPageButton").addClass("ssr_nextPageEnable");
    $("#ssr_nextPageButton").removeClass("ssr_nextPageDisable");

    $("#ssr_lastPageButton").addClass("ssr_lastPageEnable");
    $("#ssr_lastPageButton").removeClass("ssr_lastPageDisable");

    $(".ssr_statusButtonContainerForward").addClass("ssr_statusButtonContainerOver");
}

// disables the elements which navigate to the next and last pages
function DisableNextLastPage() {
    isNextStatusButtonEnable = false;

    $("#ssr_nextPageButton").addClass("ssr_nextPageDisable");
    $("#ssr_nextPageButton").removeClass("ssr_nextPageEnable");

    $("#ssr_lastPageButton").addClass("ssr_lastPageDisable");
    $("#ssr_lastPageButton").removeClass("ssr_lastPageEnable");

    $(".ssr_statusButtonContainerForward").removeClass("ssr_statusButtonContainerOver");
}

// enables the elements which navigate to the first and previous pages
function EnablePreviousFirstPage() {
    isPrevStatusButtonEnable = true;

    $("#ssr_previousPageButton").addClass("ssr_previousPageEnable");
    $("#ssr_previousPageButton").removeClass("ssr_previousPageDisable");

    $("#ssr_firstPageButton").addClass("ssr_firstPageEnable");
    $("#ssr_firstPageButton").removeClass("ssr_firstPageDisable");

    $(".ssr_statusButtonContainerBack").addClass("ssr_statusButtonContainerOver");
}

// enables the elements which navigate to the first and previous pages
function DisablePreviousFirstPage() {
    isPrevStatusButtonEnable = false;

    $("#ssr_previousPageButton").addClass("ssr_previousPageDisable");
    $("#ssr_previousPageButton").removeClass("ssr_previousPageEnable");

    $("#ssr_firstPageButton").addClass("ssr_firstPageDisable");
    $("#ssr_firstPageButton").removeClass("ssr_firstPageEnable");

    $(".ssr_statusButtonContainerBack").removeClass("ssr_statusButtonContainerOver");
}

// shows the panel with thumbnails list
function ShowThumbnailPanel() {
    HideDocumentMapPanel();
    $("#ssr_thumbnailsPanel").css("display", "block");
    $("#ssr_thumbnailButton").addClass("ssr_thumbnailButtonActive");
    $("#ssr_thumbnailButton").removeClass("ssr_thumbnailButtonDisable");
    $("#ssr_thumbnailButtonContainer").addClass("ssr_navigationButtonContainerShow");

    $("#ssr_thumbnailContentPanel").trigger("scroll");
}

// hides the panel with thumbnails list
function HideThumbnailPanel() {
    $("#ssr_thumbnailsPanel").css("display", "none");
    $("#ssr_thumbnailButton").addClass("ssr_thumbnailButtonDisable");
    $("#ssr_thumbnailButton").removeClass("ssr_thumbnailButtonActive");
    $("#ssr_thumbnailButtonContainer").removeClass("ssr_navigationButtonContainerShow");
}

// shows the panel with bookmarks tree
function ShowDocumentMapPanel() {
    HideThumbnailPanel();
    $("#ssr_documentMapPanel").css("display", "block");
    $("#ssr_documentMapButton").addClass("ssr_documentMapButtonActive");
    $("#ssr_documentMapButton").removeClass("ssr_documentMapButtonDisable");
    $("#ssr_documentMapButtonContainer").addClass("ssr_navigationButtonContainerShow");
}

// hides the panel with bookmarks tree
function HideDocumentMapPanel() {
    $("#ssr_documentMapPanel").css("display", "none");
    $("#ssr_documentMapButton").addClass("ssr_documentMapButtonDisable");
    $("#ssr_documentMapButton").removeClass("ssr_documentMapButtonActive");
    $("#ssr_documentMapButtonContainer").removeClass("ssr_navigationButtonContainerShow");
}

// enables the button which shows a dialog window with an error message
function EnableErrorButton() {
    hasError = true;

    $("#ssr_errorButton").addClass("ssr_errorButtonEnable");
    $("#ssr_errorButton").removeClass("ssr_errorButtonDisable");
}

// disables the button which shows a dialog window with an error message
function DisableErrorButton() {
    hasError = false;

    $("#ssr_errorButton").addClass("ssr_errorButtonDisable");
    $("#ssr_errorButton").removeClass("ssr_errorButtonEnable");
}

// handles the value which  a user inputs into the field with the number of the current page
function HandelInputPageNumber(control) {
    var value = parseInt($(control).val(), 10);
    if (isNaN(value)) {
        if (reportViewer != null) {
            $(control).val(reportViewer.getCurrentPage());
        }
    }
    else {
        if (value < 1) {
            $(control).val(1);
        }
        else if (value > pageCount) {
            $(control).val(pageCount);
        }
        else {
            $(control).val(value);
            reportViewer.setCurrentPage(value);
        }
    }
}
////////
